#include "CommandQueue.h"
#include "Function.h"
#include <stdio.h>
#include "log.h"
#include "string.h"

Function::Function( char* name ) {
	this->name = newstrcpy( name );
	lineIdx = 0;
	for ( int i = 0; i < MAX_LINES; i++ ) {
		lines[i] = NULL;
	}
}

void Function::addLine( char* line ) {
	lines[ lineIdx++ ] = newstrcpy( line );
}

void Function::execute( CommandQueue* cq ) {
	cq->suspend();
	for ( int i = 0; i < lineIdx; i++ ) {
		cq->queue( lines[i] );
	}
	cq->resume();
}

FunctionManager::FunctionManager() {
	functionIdx = 0;
	for ( int i = 0; i < MAX_FUNCTIONS; i++ ) {
		functions[i] = NULL;
	}
}

void FunctionManager::addFunction( Function* f ) {
	functions[ functionIdx++ ] = f;
}

void FunctionManager::execute( CommandQueue* cq, char* functionName ) {
	log_message1( "FunctionManager::execute function", functionName );
	for ( int i = 0; i < functionIdx; i++ ) {
		if ( strcmp( functionName, functions[i]->getName() ) == 0 ) {
			log_message( "FOUND THE FUNCTION" );
			functions[i]->execute( cq );
			return;
		}
	}
	log_message( "DID NOT FIND THE FUNCTION" );
}