#include "ModelSetManager.h"
#include <stdio.h>
#include "log.h"
#include <string.h>

ModelSetManager::ModelSetManager() {
	modelSetIdx = 0;
	foundIdx = -1;
}

bool ModelSetManager::next() {
	//log_messagei1("ModelSetManager::next", foundIdx );
	if ( foundIdx != -1 ) {
		modelSets[ foundIdx ]->next();
		return( true );
	} else {
		log_message("no foundIdx" );
		return( false );
	}
}

int ModelSetManager::getNumberObjects() {
	if ( foundIdx == -1 ) {
		//log_message( "foundIdx is not there.." );
		return( 0 );
	} else {
		//log_messagei1( "foundIdx is", foundIdx );
		return( modelSets[ foundIdx ]->getCount() );
	}
}
void ModelSetManager::RegisterModelSet( ModelSet* ms ) {
	modelSets[ modelSetIdx++ ] = ms;
}

char* ModelSetManager::xlateName( char* name ) {
	//foundIdx = -1;
	for ( int i = 0; i < modelSetIdx; i++ ) {
		ModelSet* ms = modelSets[i];
		if ( ms->hasName( name )) {
			foundIdx = i;
			return( ms->getName() );
		}
	}
	return( NULL );
}

void ModelSetManager::registerIdx( int idx ) {
	if ( foundIdx != -1 ) {
		//log_message(" calling model set register idx" );
		modelSets[ foundIdx ]->registerIdx( idx );
	} //else log_message("foundIdx is GONE" );
}

void ModelSetManager::registerValue( int idx ) {
	if ( foundIdx != -1 ) {
		//log_message( "calling model set register value" );
		modelSets[ foundIdx ]->registerValue( idx );
	} //else log_message("foundIdx is GONE" );
}



char* ModelSetManager::getObjectAt( int offset ) {
	return( modelSets[ foundIdx ]->getNameAt( offset ));
}

ModelSet::ModelSet( char* mname, int mcount ) {
	name = newstrcpy( mname );
	count = mcount;
	currentIdx = 0;
	valueSetForIdx = false;
	valueIdx = -1;
}

void ModelSet::next() {
	//log_message1("ModelSet::next", name );
	//log_messagei1("ModelSet::next", valueSetForIdx );
	if ( valueSetForIdx ) {
		//log_message("value was set, I'm switching" );
		currentIdx++;
		if ( currentIdx >= count ) {
			currentIdx = 0;
		}
	} //else { log_message("value not set, NOT switching" ); }
	//log_messagei1("result currentIdx is", currentIdx );
}

bool ModelSet::hasName( char* n ) {
	return( strcmp( n, name ) == 0 );
}

char* ModelSet::getNameAt( int offset ) {
	int saveCurrentIdx = currentIdx;
	currentIdx = offset;
	char* result = getName();
	currentIdx = saveCurrentIdx;
	return( result );
}

char* ModelSet::getName() {
	static char result[100];
	sprintf( result, "%s_%d", name, currentIdx );
	//log_message1( "getName result: ", result );
	return( &result[0] );
}

void ModelSet::registerIdx( int idx ) {
	if ( idx != valueIdx ) {
		valueIdx = idx; 
		valueSetForIdx = false; 
	}
	//log_message1( "ModelSet::registerIdx:", name );
	//log_messagei1( "valueIdx:", valueIdx );
	//log_message1( name, "FALSE" );
}
	
void ModelSet::registerValue( int idx ) { 
	//log_message1("ModelSet::registerValue", name);
	if ( idx == valueIdx ) {
		valueSetForIdx = true; 
		//log_message("it worked");
		//log_message1( name, "TRUE" );
	} else {
		//log_messagei1("ModelSet registerValue failed, idx", idx );
	}
}
